# FILE: avf2odt.tcl
#
# This file must be evaluated by mmDispSh

package require Oc 1.1.1.0
package require Mmdispcmds 1.1.1.0
Oc_ForceStderrDefaultMessage
catch {wm withdraw .}

Oc_Main SetAppName avf2odt
Oc_Main SetVersion 1.2.0.3

set regionstr [list - - - - - -]
set avetype "space"
set axis "x"

Oc_CommandLine Option console {} {}
Oc_CommandLine Option average {
    {manifold {regexp {^(space|plane|line|point)$} $manifold}
    {is one of {space,plane,line,point}} }
} { global avetype; set avetype $manifold } { Averaging type}
Oc_CommandLine Option axis {
    {spec {regexp {^[xyz]$} $spec} {is one of {x,y,z}} }
} { global axis; set axis $spec } { Axis averaging specification}
Oc_CommandLine Option region {
    {xmin {regexp {^[-+.e0-9]+$} $xmin} {}}
    {ymin {regexp {^[-+.e0-9]+$} $ymin} {}}
    {zmin {regexp {^[-+.e0-9]+$} $zmin} {}}
    {xmax {regexp {^[-+.e0-9]+$} $xmax} {}}
    {ymax {regexp {^[-+.e0-9]+$} $ymax} {}}
    {zmax {regexp {^[-+.e0-9]+$} $zmax} {}}
} { global regionstr; set regionstr [list $xmin $ymin $zmin $xmax $ymax $zmax]
} {  Volume select}
Oc_CommandLine Option [Oc_CommandLine Switch] {
	{file {} {Input vector field file (regular grid)}}
    } {
	global infile; set infile $file
    } {End of options; next argument is file}
Oc_CommandLine Parse $argv

ChangeMesh $infile 0 0 0 -1
WriteMeshAverages stdout $avetype $axis $regionstr \
	"Data from vector field file $infile"

exit 0
