/* FILE: linearscalarfield.cc     -*-Mode: c++-*-
 *
 * Linear scalar field, derived from Oxs_ScalarField class.
 *
 */

#include "oc.h"
#include "nb.h"

#include "linearscalarfield.h"

// Oxs_Ext registration support
OXS_EXT_REGISTER(Oxs_LinearScalarField);

/* End includes */


// Constructor
Oxs_LinearScalarField::Oxs_LinearScalarField(
  const char* name,     // Child instance id
  Oxs_Director* newdtr, // App director
  const char* argstr)   // MIF input block parameters
  : Oxs_ScalarField(name,newdtr,argstr)
{
  // Process arguments
  vec = GetThreeVectorInitValue("vector");
  if(HasInitValue("norm")) {
    vec.SetMag(GetRealInitValue("norm"));
  }
  VerifyAllInitArgsUsed();
}

BOOL Oxs_LinearScalarField::Init()
{ return 1; }

REAL8m
Oxs_LinearScalarField::Value
(const ThreeVector& pt) const
{
  return vec*pt;
}

void
Oxs_LinearScalarField::FillMeshValue
(const Oxs_Mesh* mesh,
 Oxs_MeshValue<REAL8m>& array) const
{
  DefaultFillMeshValue(mesh,array);
}
