/* FILE: planerandomvectorfield.h      -*-Mode: c++-*-
 *
 * Vector field object, random in a specified plane.
 * Derived from Oxs_VectorField class.
 *
 */

#ifndef _OXS_PLANERANDOMVECTORFIELD
#define _OXS_PLANERANDOMVECTORFIELD

#include "oc.h"

#include "vectorfield.h"

/* End includes */

class Oxs_PlaneRandomVectorField:public Oxs_VectorField {
private:
  REAL8m min_norm;
  REAL8m max_norm;
  REAL8m norm_range;
  ThreeVector plane_normal;
public:
  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.
  virtual BOOL Init();
  Oxs_PlaneRandomVectorField
  (const char* name,     // Child instance id
   Oxs_Director* newdtr, // App director
   const char* argstr);  // MIF input block parameters

  virtual ~Oxs_PlaneRandomVectorField() {}

  virtual void Value(const ThreeVector& pt,ThreeVector& value) const;

  virtual void FillMeshValue(const Oxs_Mesh* mesh,
			     Oxs_MeshValue<ThreeVector>& array) const {
    DefaultFillMeshValue(mesh,array);
  }

  virtual void
  FillMeshValueOrthogonal(const Oxs_Mesh* mesh,
			  const Oxs_MeshValue<ThreeVector>& orth_array,
			  Oxs_MeshValue<ThreeVector>& array) const;

};


#endif // _OXS_PLANERANDOMVECTORFIELD

