/* FILE: byte.h                       -*-Mode: c++-*-
 *
 *	Routines which convert endian of data
 * 
 * NOTICE: Please see the file ../../LICENSE
 *
 * Last modified on: $Date: 2002/10/25 20:49:02 $
 * Last modified by: $Author: donahue $
 */

#ifndef _OC_BYTE
#define _OC_BYTE

#include "ocport.h"
/* End includes */     /* Optional directive to pimake */

/* Inline declarations */
inline void Oc_Flip2(void* input);
inline void Oc_Flip4(void* input);
inline void Oc_Flip8(void* input);  // May be too big to inline

/* Prototypes for the routines defined in byte.cc */
void Oc_SwapWords4(void *buf,INT4m count);
void Oc_SwapWords8(void *buf,INT4m count);
void Oc_SwapBuf(void *buf,INT4m wordsize,INT4m wordcount);
  // Converts the array 'buf' from big endian to little endian
  // (or vice versa), where each word is of width 'wordsize',
  // and there are 'wordcount' elements (words) in the array.

/* Inline implementations */
inline void Oc_Flip2(void* input)
{ // In place byte reversal for all 2 byte wide types.
  UCHAR temp;
  UCHAR* byte=(UCHAR*)input;
  temp=byte[0]; byte[0]=byte[1]; byte[1]=temp;
}

inline void Oc_Flip4(void* input)
{ // In place byte reversal for all 4 byte wide types.
  UCHAR temp;
  UCHAR* byte=(UCHAR*)input;
  temp=byte[1]; byte[1]=byte[2]; byte[2]=temp;
  temp=byte[0]; byte[0]=byte[3]; byte[3]=temp;
}

inline void Oc_Flip8(void* input)
{ // In place byte reversal for all 4 byte wide types.
  // Probably too big to be inlined.
  UCHAR temp;
  UCHAR* byte=(UCHAR*)input;
  temp=byte[3]; byte[3]=byte[4]; byte[4]=temp;
  temp=byte[2]; byte[2]=byte[5]; byte[5]=temp;
  temp=byte[1]; byte[1]=byte[6]; byte[6]=temp;
  temp=byte[0]; byte[0]=byte[7]; byte[7]=temp;
}

#endif /* _OC_BYTE */
